> For the complete documentation index, see [llms.txt](https://docs.rowsncolumns.app/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rowsncolumns.app/excel-and-google-sheets/csv.md).

# CSV

Use the `@rowsncolumns/toolkit` package to read, write and download CSV files from `SheetData` object

{% hint style="info" %}
`@rowsncolumns/toolkit` is dependent on `@rowsncolumns/spreadsheet-state` package, and expects sheet data in `type SheetData` format
{% endhint %}

## Import from CSV

```typescript
import { createRowDataFromCSVFile } from "@rowsncolumns/toolkit";

const App = () => {
  const handleChange = async (e) => {
    const file = e.target.files[0]
    const rowData = await createRowDataFromCSVFile(file)
    const newSheetId = uuid()
    
    onChangSheetData(prev => {
      return {
        ...prev,
        [newSheetId]: rowData
      }
    })
  }
  return (
    <div>
      <input type="file" onChange={handleChange} />
    </div>
  )
}
```

## Export to CSV

```tsx
import { exportToCSV } from "@rowsncolumns/toolkit";

const App = () => {
  const [ sheetData, onChangeSheetData] = useState<SheetData>()
  
  return (
    <div>
      <button onClick={() => exportToCSV({ filename: 'csvfile', rowData: sheetData[1] }) }>Export to CSV</button>
      <CanvasGrid />
    </div>
  )
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.rowsncolumns.app/excel-and-google-sheets/csv.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
